module Pairs where

import Monad

pairs :: Int -> [(Int,Int)]
pairs n  =  [ (i,j) | i <- [1..n], j <- [(i+1)..n] ]

pairs' :: Int -> [(Int,Int)]
pairs' n  =  do { i <- [1..n];
                  j <- [(i+1)..n];
                  return (i,j) }

prop_pairs :: Int -> Bool
prop_pairs n  =  pairs n == pairs' n

pairs'' :: Int -> [(Int, Int)]
pairs'' n  =  [ (i,j) | i <- [1..n], j <- [1..n], i < j ]

pairs''' :: Int -> [(Int, Int)]
pairs''' n  =  do {
                 i <- [1..n];
                 j <- [1..n];
                 guard (i < j);
                 return (i,j)
               }

prop_pairs' :: Int -> Bool
prop_pairs' n  =  pairs'' n == pairs''' n

