module RandomState where

import StateMonad
import Random

-- data StdGen
-- next  :: StdGen -> (Int, StdGen)
-- newStdGen :: IO StdGen

chooseOne  :: State StdGen Int 
chooseOne  =  State next

-- sequence []
-- sequence (m:ms)  =  do {
--                       x <- m;
--                       xs <- sequence ms;
--                       return (x:xs)
--                     }

chooseMany :: Int -> State StdGen [Int]
chooseMany 0      =  return []
chooseMany (n+1)  =  do {
                       x <- chooseOne;
                       xs <- chooseMany n;
                       return (x:xs)
                     }

chooseMany' :: Int -> State StdGen [Int]
chooseMany' n  =  sequence (replicate n chooseOne)

io :: State StdGen a -> IO a
io m  =  do {
            stdgen <- newStdGen;
            let (x, stdgen') = apply m stdgen in
              return x
          }

main :: IO ()
main =  do {
          xs <- io (chooseMany 5);
          print xs;
          ys <- io (chooseMany 5);
          print ys
        }
